Index: issm/branches/trunk-jpl-damage/src/c/modules/DakotaResponsesx/DakotaResponsesx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/DakotaResponsesx/DakotaResponsesx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/DakotaResponsesx/DakotaResponsesx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _DAKOTARESPONSESXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/DakotaFree.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/DakotaFree.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/DakotaFree.cpp	(revision 12878)
@@ -22,8 +22,8 @@
 	extern int my_rank;
 	
-	double* variables=NULL;
-	char**  variables_descriptors=NULL;
-	char**  responses_descriptors=NULL;
-	char*   string=NULL;
+	double  *variables             = NULL;
+	char   **variables_descriptors = NULL;
+	char   **responses_descriptors = NULL;
+	char    *string                = NULL;
 
 	/*recover pointers: */
@@ -35,10 +35,10 @@
 	/*Free variables and variables_descriptors only on cpu !=0*/
 	if(my_rank!=0){
-		xfree((void**)&variables);
+		xDelete<double>(variables);
 		for(i=0;i<numvariables;i++){
 			string=variables_descriptors[i];
-			xfree((void**)&string);
+			xDelete<char>(string);
 		}
-		xfree((void**)&variables_descriptors);
+		xDelete<char*>(variables_descriptors);
 	}
 	
@@ -46,8 +46,8 @@
 	for(i=0;i<numresponses;i++){
 		string=responses_descriptors[i];
-		xfree((void**)&string);
+		xDelete<char>(string);
 	}
 	//rest of dynamic allocations.
-	xfree((void**)&responses_descriptors);
+	xDelete<char*>(responses_descriptors);
 
 	/*Assign output pointers:*/
@@ -56,3 +56,2 @@
 	*presponses_descriptors=responses_descriptors;
 }
-
Index: issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/DakotaMPI_Bcast.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/DakotaMPI_Bcast.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/DakotaMPI_Bcast.cpp	(revision 12878)
@@ -38,10 +38,10 @@
 	
 	/*variables:*/
-	if(my_rank!=0)variables=(double*)xmalloc(numvariables*sizeof(double));
+	if(my_rank!=0)variables=xNew<double>(numvariables);
 	MPI_Bcast(variables,numvariables,MPI_DOUBLE,0,MPI_COMM_WORLD); 
 
 	/*variables_descriptors: */
 	if(my_rank!=0){
-		variables_descriptors=(char**)xmalloc(numvariables*sizeof(char*));
+		variables_descriptors=xNew<char*>(numvariables);
 	}
 	for(i=0;i<numvariables;i++){
@@ -51,5 +51,5 @@
 		}
 		MPI_Bcast(&string_length,1,MPI_INT,0,MPI_COMM_WORLD); 
-		if(my_rank!=0)string=(char*)xmalloc(string_length);
+		if(my_rank!=0)string=xNew<char>(string_length);
 		MPI_Bcast(string,string_length,MPI_CHAR,0,MPI_COMM_WORLD); 
 		if(my_rank!=0)variables_descriptors[i]=string;
Index: issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/Dakotax.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/Dakotax.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/Dakotax.cpp	(revision 12878)
@@ -40,5 +40,5 @@
 #include "../../toolkits/toolkits.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
-#include "../../objects/DakotaPlugin.h"
+#include "../../classes/dakota/DakotaPlugin.h"
 
 #ifdef _HAVE_DAKOTA_ //only works if dakota library has been compiled in.
@@ -121,7 +121,7 @@
 
 	/*Free ressources:*/
-	xfree((void**)&dakota_input_file);
-	xfree((void**)&dakota_error_file);
-	xfree((void**)&dakota_output_file);
+	xDelete<char>(dakota_input_file);
+	xDelete<char>(dakota_error_file);
+	xDelete<char>(dakota_output_file);
 
 	#endif //#ifdef _HAVE_DAKOTA_
Index: issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/Dakotax.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/Dakotax.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/Dakotax.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/classes.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/DescriptorIndex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/DescriptorIndex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/DescriptorIndex.cpp	(revision 12878)
@@ -23,10 +23,10 @@
 	/*retrieve first token, separated by underscore: */
 	pch = strtok (descriptor,"_");
-	if(!pch)_error_("%s%s%s"," descriptor ",descriptor," is not correctly formatted!");
+	if(!pch)_error2_("descriptor " << descriptor << " is not correctly formatted!");
 
 	if (strncmp(pch,"scaled",6)==0){
 		/*we have a scaled variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error_("%s%s%s"," scaled descriptor ",descriptor," is not correctly formatted!");
+		if(!pch)_error2_("scaled descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 
@@ -44,9 +44,9 @@
 		/*we have an indexed variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error_("%s%s%s"," indexed descriptor ",descriptor," is not correctly formatted!");
+		if(!pch)_error2_("indexed descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 		/*now recover  the index: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error_("%s%s%s"," indexed descriptor ",descriptor," is not correctly formatted!");
+		if(!pch)_error2_("indexed descriptor " << descriptor << " is not correctly formatted!");
 		sscanf(pch,"%i",pindex);
 		return IndexedEnum;
@@ -55,9 +55,9 @@
 		/*we have an indexed variable. recover the root: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error_("%s%s%s"," nodal descriptor ",descriptor," is not correctly formatted!");
+		if(!pch)_error2_("nodal descriptor " << descriptor << " is not correctly formatted!");
 		memcpy(root,pch,(strlen(pch)+1)*sizeof(char));
 		/*now recover  the index: */
 		pch = strtok (NULL, "_");
-		if(!pch)_error_("%s%s%s"," nodal descriptor ",descriptor," is not correctly formatted!");
+		if(!pch)_error2_("nodal descriptor " << descriptor << " is not correctly formatted!");
 		sscanf(pch,"%i",pindex);
 		return NodalEnum;
Index: issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/SpawnCore.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/SpawnCore.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/SpawnCore.cpp	(revision 12878)
@@ -10,5 +10,5 @@
 
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../io/io.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
Index: issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/SpawnCoreParallel.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/SpawnCoreParallel.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Dakotax/SpawnCoreParallel.cpp	(revision 12878)
@@ -26,5 +26,5 @@
 
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../io/io.h"
 #include "../../EnumDefinitions/EnumDefinitions.h"
@@ -53,5 +53,5 @@
 	/*synchronize all cpus, as CPU 0 is probably late (it is starting the entire dakota strategy!) : */
 	MPI_Barrier(MPI_COMM_WORLD);
-	_printf_(VerboseQmu(),"qmu iteration: %i\n",counter);
+	if(VerboseQmu()) _pprintLine_("qmu iteration: " << counter);
 	
 	/*retrieve parameters: */
@@ -67,10 +67,10 @@
 
 	/*Determine solution sequence: */
-	_printf_(VerboseQmu(),"%s%s%s\n","Starting ",EnumToStringx(solution_type)," core:");
+	if(VerboseQmu()) _pprintLine_("Starting " << EnumToStringx(solution_type) << " core:");
 	CorePointerFromSolutionEnum(&solutioncore,femmodel->parameters,solution_type);
 	#ifdef _HAVE_CONTROL_
 	if(control_analysis)solutioncore=&control_core;
 	#else
-	_error_("ISSM was not compiled with control capabilities, exiting!");
+	_error2_("ISSM was not compiled with control capabilities, exiting!");
 	#endif
 
@@ -79,5 +79,5 @@
 
 	/*compute responses: */
-	_printf_(VerboseQmu(),"compute dakota responses:\n");
+	if(VerboseQmu()) _pprintLine_("compute dakota responses:");
 	DakotaResponsesx(d_responses,femmodel->elements,femmodel->nodes,femmodel->vertices,femmodel->loads,femmodel->materials,femmodel->parameters,responses_descriptors,numresponsedescriptors,d_numresponses);
 	
Index: issm/branches/trunk-jpl-damage/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.cpp	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.cpp	(revision 12878)
@@ -0,0 +1,23 @@
+/*!\file Delta18oParameterizationx
+ * \brief: Create past temperature field from present day fields
+ */
+
+#include "./Delta18oParameterizationx.h"
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../io/io.h"
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+
+void Delta18oParameterizationx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters){
+
+  /*Intermediary*/
+  int    i;
+  Element* element = NULL;
+ 
+  /*Compute temperature and precipitation fields: */
+  for(i=0;i<elements->Size();i++){
+    element=(Element*)elements->GetObjectByOffset(i);
+    element->Delta18oParameterization();
+  }  
+}
Index: issm/branches/trunk-jpl-damage/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.h	(revision 12878)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Delta18oParameterizationx/Delta18oParameterizationx.h	(revision 12878)
@@ -0,0 +1,14 @@
+/*!\file:  Delta18oParameterizationx.cpp
+ * \brief header file for 
+ */ 
+
+#ifndef _DELTA18OPARAMETERIZATIONX_H
+#define _DELTA18OPARAMETERIZATIONX_H
+
+#include "../../Container/Container.h"
+#include "../../classes/objects/objects.h"
+
+/* local prototypes: */
+void Delta18oParameterizationx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters);
+
+#endif  /* _DELTA18OPARAMETERIZATIONX_H*/
Index: issm/branches/trunk-jpl-damage/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/DragCoefficientAbsGradientx/DragCoefficientAbsGradientx.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/ElementConnectivityx/ElementConnectivityx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ElementConnectivityx/ElementConnectivityx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ElementConnectivityx/ElementConnectivityx.cpp	(revision 12878)
@@ -36,5 +36,5 @@
 	maxels=width-1;
 	/*Allocate connectivity: */
-	elementconnectivity=(double*)xcalloc(nel*3,sizeof(double));
+	elementconnectivity=xNewZeroInit<double>(nel*3);
 
 	/*Go through all elements, and for each element, go through its nodes, to get the neighbouring elements. 
Index: issm/branches/trunk-jpl-damage/src/c/modules/ElementResponsex/ElementResponsex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ElementResponsex/ElementResponsex.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ElementResponsex/ElementResponsex.cpp	(revision 12878)
@@ -39,5 +39,5 @@
 	#ifdef _HAVE_MPI_
 	MPI_Allreduce ( &found,&sumfound,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
-	if(!sumfound)_error_("%s%i%s","could not find material with id",index," to compute ElementResponse");
+	if(!sumfound)_error2_("could not find material with id" << index << " to compute ElementResponse");
 	#endif
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/ElementResponsex/ElementResponsex.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ElementResponsex/ElementResponsex.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ElementResponsex/ElementResponsex.h	(revision 12878)
@@ -7,5 +7,5 @@
 
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/EnumToStringx/EnumToStringx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/EnumToStringx/EnumToStringx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/EnumToStringx/EnumToStringx.cpp	(revision 12878)
@@ -8,4 +8,5 @@
 */
 
+#include <cstring>
 #include "../../shared/shared.h"
 #include "../../include/include.h"
@@ -109,4 +110,5 @@
 		case MaterialsRhoIceEnum : return "MaterialsRhoIce";
 		case MaterialsRhoWaterEnum : return "MaterialsRhoWater";
+		case MaterialsRhoFreshwaterEnum : return "MaterialsRhoFreshwater";
 		case MaterialsMuWaterEnum : return "MaterialsMuWater";
 		case MaterialsThermalExchangeVelocityEnum : return "MaterialsThermalExchangeVelocity";
@@ -154,8 +156,14 @@
 		case SettingsResultsAsPatchesEnum : return "SettingsResultsAsPatches";
 		case SettingsWaitonlockEnum : return "SettingsWaitonlock";
-		case DebugPetscProfilingEnum : return "DebugPetscProfiling";
-		case PetscProfilingCurrentMemEnum : return "PetscProfilingCurrentMem";
-		case PetscProfilingCurrentFlopsEnum : return "PetscProfilingCurrentFlops";
-		case PetscProfilingSolutionTimeEnum : return "PetscProfilingSolutionTime";
+		case SurfaceforcingsDelta18oEnum : return "SurfaceforcingsDelta18o";
+		case SurfaceforcingsDelta18oSurfaceEnum : return "SurfaceforcingsDelta18oSurface";
+		case SurfaceforcingsIsdelta18oEnum : return "SurfaceforcingsIsdelta18o";
+		case SurfaceforcingsPrecipitationsPresentdayEnum : return "SurfaceforcingsPrecipitationsPresentday";
+		case SurfaceforcingsTemperaturesPresentdayEnum : return "SurfaceforcingsTemperaturesPresentday";
+		case SurfaceforcingsTemperaturesLgmEnum : return "SurfaceforcingsTemperaturesLgm";
+		case DebugProfilingEnum : return "DebugProfiling";
+		case ProfilingCurrentMemEnum : return "ProfilingCurrentMem";
+		case ProfilingCurrentFlopsEnum : return "ProfilingCurrentFlops";
+		case ProfilingSolutionTimeEnum : return "ProfilingSolutionTime";
 		case MaxIterationConvergenceFlagEnum : return "MaxIterationConvergenceFlag";
 		case SteadystateMaxiterEnum : return "SteadystateMaxiter";
@@ -166,4 +174,14 @@
 		case SurfaceforcingsPrecipitationEnum : return "SurfaceforcingsPrecipitation";
 		case SurfaceforcingsMassBalanceEnum : return "SurfaceforcingsMassBalance";
+		case SurfaceforcingsIspddEnum : return "SurfaceforcingsIspdd";
+		case SurfaceforcingsIssmbgradientsEnum : return "SurfaceforcingsIssmbgradients";
+		case SurfaceforcingsMonthlytemperaturesEnum : return "SurfaceforcingsMonthlytemperatures";
+		case SurfaceforcingsHcEnum : return "SurfaceforcingsHc";
+		case SurfaceforcingsSmbPosMaxEnum : return "SurfaceforcingsSmbPosMax";
+		case SurfaceforcingsSmbPosMinEnum : return "SurfaceforcingsSmbPosMin";
+		case SurfaceforcingsAPosEnum : return "SurfaceforcingsAPos";
+		case SurfaceforcingsBPosEnum : return "SurfaceforcingsBPos";
+		case SurfaceforcingsANegEnum : return "SurfaceforcingsANeg";
+		case SurfaceforcingsBNegEnum : return "SurfaceforcingsBNeg";
 		case ThermalMaxiterEnum : return "ThermalMaxiter";
 		case ThermalPenaltyFactorEnum : return "ThermalPenaltyFactor";
@@ -257,4 +275,5 @@
 		case IntParamEnum : return "IntParam";
 		case IntVecParamEnum : return "IntVecParam";
+		case TransientParamEnum : return "TransientParam";
 		case MacAyeal2dIceFrontEnum : return "MacAyeal2dIceFront";
 		case MacAyeal3dIceFrontEnum : return "MacAyeal3dIceFront";
@@ -376,4 +395,5 @@
 		case StressTensorzzEnum : return "StressTensorzz";
 		case IceVolumeEnum : return "IceVolume";
+		case TotalSmbEnum : return "TotalSmb";
 		case P0Enum : return "P0";
 		case P1Enum : return "P1";
@@ -464,5 +484,5 @@
 
 	len=strlen(EnumToStringx(enum_in));
-	string=(char*)xmalloc((len+1)*sizeof(char));
+	string=xNew<char>(len+1);
 	memcpy(string,EnumToStringx(enum_in),(len+1)*sizeof(char));
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/Exp2Kmlx/Exp2Kmlx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Exp2Kmlx/Exp2Kmlx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Exp2Kmlx/Exp2Kmlx.cpp	(revision 12878)
@@ -11,29 +11,22 @@
 #include "../modules.h"
 
-int Exp2Kmlx(char* filexp,char* filkml,
-			 int sgn,
-			 bool holes){
+int Exp2Kmlx(char* filexp,char* filkml,int sgn,bool holes){
 
 	double  cm,sp;
 
 	Xy2lldef(&cm,&sp,sgn);
-
-	return(Exp2Kmlx(filexp,filkml,
-					sgn,cm,sp,
-					holes));
+	return(Exp2Kmlx(filexp,filkml,sgn,cm,sp,holes));
 }
 
-int Exp2Kmlx(char* filexp,char* filkml,
-			 int sgn,double cm,double sp,
-			 bool holes){
-
-	int     i,j,iret=0;
-	int     lwidth=1;
-	double  popac=0.50;
-	int     nprof;
-	int     *pnvert=NULL;
-	double  **pprofx=NULL,**pprofy=NULL;
-	bool    *closed=NULL;
-	double  *lat=NULL,*lon=NULL;
+int Exp2Kmlx(char* filexp,char* filkml,int sgn,double cm,double sp,bool holes){
+
+	int      i        ,j,iret=0;
+	int      lwidth = 1;
+	double   popac  = 0.50;
+	int      nprof;
+	int     *pnvert = NULL;
+	double **pprofx = NULL,**pprofy=NULL;
+	bool    *closed = NULL;
+	double  *lat    = NULL, *lon=NULL;
 
 	char    indent[81]="";
@@ -57,13 +50,13 @@
 	clock0=clock();
 	time0 =time(NULL);
-	_printf_(true,"\nExp2Kmlx Module -- %s",ctime(&time0));
-
-/*  read exp file  */
+	_pprintString_("\nExp2Kmlx Module -- " << ctime(&time0));
+
+	/*read exp file  */
 
 	if (!DomainOutlineRead(&nprof,&pnvert,&pprofx,&pprofy,&closed,filexp))
-		_error_("Error reading exp file.");
-	_printf_(true,"Exp2Kmlx -- Reading %d exp profiles from file \"%s\".\n",nprof,filexp);
+		_error2_("Error reading exp file.");
+	_pprintLine_("Exp2Kmlx -- Reading " << nprof << " exp profiles from file \"" << filexp << "\".");
 //	for (i=0; i<nprof; i++)
-//		printf("i=%d; nvert=%d, closed=%d\n",i,pnvert[i],closed[i]);
+//		_printLine_("i=" << i << "; nvert=" << pnvert[i] << ", closed=" << closed[i]);
 
 /*  construct kml file  */
@@ -128,5 +121,5 @@
 
 	if (holes && nprof && (pnvert[0] <= 1 || pprofx[0][pnvert[0]-1] != pprofx[0][0] || pprofy[0][pnvert[0]-1] != pprofy[0][0])) {
-		_printf_(true,"Warning -- Outer profile is not closed, so \"holes\" option will be ignored.\n");
+		_pprintLine_("Warning -- Outer profile is not closed, so \"holes\" option will be ignored.");
 		holes=false;
 	}
@@ -143,15 +136,15 @@
 
 		kring->ncoord    =pnvert[i]-1;
-		lat=(double *) xmalloc(kring->ncoord*sizeof(double));
-		lon=(double *) xmalloc(kring->ncoord*sizeof(double));
+		lat=xNew<double>(kring->ncoord);
+		lon=xNew<double>(kring->ncoord);
 		Xy2llx(lat,lon,pprofx[i],pprofy[i],kring->ncoord,sgn,cm,sp);
-		kring->coords    =(double (*)[3]) xmalloc(kring->ncoord*3*sizeof(double));
+		kring->coords=xNew<double>(kring->ncoord*3);
 		for (j=0; j<kring->ncoord; j++) {
-			kring->coords[j][0]=lon[j];
-			kring->coords[j][1]=lat[j];
-			kring->coords[j][2]=0.;
+			kring->coords[3*j+0]=lon[j];
+			kring->coords[3*j+1]=lat[j];
+			kring->coords[3*j+2]=0.;
 		}
-		xfree((void**)&lon);
-		xfree((void**)&lat);
+		xDelete<double>(lon);
+		xDelete<double>(lat);
 
 		(kpoly ->outer     )->AddObject((Object*)kring);
@@ -160,5 +153,5 @@
 		for (i=1; i<nprof; i++) {
 			if (pnvert[i] <= 1 || pprofx[i][pnvert[i]-1] != pprofx[i][0] || pprofy[i][pnvert[i]-1] != pprofy[i][0]) {
-				_printf_(true,"Warning -- Inner profile %d is not closed with \"holes\" specified, so it will be ignored.\n",i+1);
+				_pprintLine_("Warning -- Inner profile " << i+1 << " is not closed with \"holes\" specified, so it will be ignored.");
 				continue;
 			}
@@ -167,15 +160,15 @@
 
 			kring->ncoord    =pnvert[i]-1;
-			lat=(double *) xmalloc(kring->ncoord*sizeof(double));
-			lon=(double *) xmalloc(kring->ncoord*sizeof(double));
+			lat=xNew<double>(kring->ncoord);
+			lon=xNew<double>(kring->ncoord);
 			Xy2llx(lat,lon,pprofx[i],pprofy[i],kring->ncoord,sgn,cm,sp);
-			kring->coords    =(double (*)[3]) xmalloc(kring->ncoord*3*sizeof(double));
+			kring->coords    =xNew<double>(kring->ncoord*3);
 			for (j=0; j<kring->ncoord; j++) {
-				kring->coords[j][0]=lon[j];
-				kring->coords[j][1]=lat[j];
-				kring->coords[j][2]=0.;
-			}
-			xfree((void**)&lon);
-			xfree((void**)&lat);
+				kring->coords[3*j+0]=lon[j];
+				kring->coords[3*j+1]=lat[j];
+				kring->coords[3*j+2]=0.;
+			}
+			xDelete<double>(lon);
+			xDelete<double>(lat);
 
 			(kpoly ->inner     )->AddObject((Object*)kring);
@@ -204,15 +197,15 @@
 
 				kring->ncoord    =pnvert[i]-1;
-				lat=(double *) xmalloc(kring->ncoord*sizeof(double));
-				lon=(double *) xmalloc(kring->ncoord*sizeof(double));
+				lat=xNew<double>(kring->ncoord);
+				lon=xNew<double>(kring->ncoord);
 				Xy2llx(lat,lon,pprofx[i],pprofy[i],kring->ncoord,sgn,cm,sp);
-				kring->coords    =(double (*)[3]) xmalloc(kring->ncoord*3*sizeof(double));
+				kring->coords    =xNew<double>(kring->ncoord*3);
 				for (j=0; j<kring->ncoord; j++) {
-					kring->coords[j][0]=lon[j];
-					kring->coords[j][1]=lat[j];
-					kring->coords[j][2]=0.;
+					kring->coords[3*j+0]=lon[j];
+					kring->coords[3*j+1]=lat[j];
+					kring->coords[3*j+2]=0.;
 				}
-				xfree((void**)&lon);
-				xfree((void**)&lat);
+				xDelete<double>(lon);
+				xDelete<double>(lat);
 
 				(kpoly ->outer     )->AddObject((Object*)kring);
@@ -231,15 +224,15 @@
 
 				kline->ncoord    =pnvert[i];
-				lat=(double *) xmalloc(kline->ncoord*sizeof(double));
-				lon=(double *) xmalloc(kline->ncoord*sizeof(double));
+				lat=xNew<double>(kline->ncoord);
+				lon=xNew<double>(kline->ncoord);
 				Xy2llx(lat,lon,pprofx[i],pprofy[i],kline->ncoord,sgn,cm,sp);
-				kline->coords    =(double (*)[3]) xmalloc(kline->ncoord*3*sizeof(double));
+				kline->coords    =xNew<double>(kline->ncoord*3);
 				for (j=0; j<kline->ncoord; j++) {
-					kline->coords[j][0]=lon[j];
-					kline->coords[j][1]=lat[j];
-					kline->coords[j][2]=0.;
+					kline->coords[3*j+0]=lon[j];
+					kline->coords[3*j+1]=lat[j];
+					kline->coords[3*j+2]=0.;
 				}
-				xfree((void**)&lon);
-				xfree((void**)&lat);
+				xDelete<double>(lon);
+				xDelete<double>(lat);
 
 				(kplace->geometry  )->AddObject((Object*)kline);
@@ -251,15 +244,16 @@
 				kplace->visibility=true;
 				sprintf(kplace->styleurl  ,"#RandomLineEmptyPoly");
+				int one=1;
 
 				kpoint=new KML_Point();
 
-				lat=(double *) xmalloc(sizeof(double));
-				lon=(double *) xmalloc(sizeof(double));
+				lat=xNew<double>(one);
+				lon=xNew<double>(one);
 				Xy2llx(lat,lon,pprofx[i],pprofy[i],1,sgn,cm,sp);
 				kpoint->coords[0]=lon[0];
 				kpoint->coords[1]=lat[0];
 				kpoint->coords[2]=0.;
-				xfree((void**)&lon);
-				xfree((void**)&lat);
+				xDelete<double>(lon);
+				xDelete<double>(lat);
 
 				(kplace->geometry  )->AddObject((Object*)kpoint);
@@ -281,5 +275,5 @@
 /*  write kml file  */
 
-	_printf_(true,"Exp2Kmlx -- Writing kml document to file \"%s\".\n",filkml);
+	_pprintLine_("Exp2Kmlx -- Writing kml document to file \"" << filkml << "\".");
 	fid=fopen(filkml,"w");
 	fprintf(fid,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
@@ -289,8 +283,8 @@
 	delete kfile;
 	for (i=nprof-1; i>=0; i--) {
-		xfree((void**)&(pprofy[i]));
-		xfree((void**)&(pprofx[i]));
-	}
-	xfree((void**)&pnvert);
+		xDelete<double>(pprofy[i]);
+		xDelete<double>(pprofx[i]);
+	}
+	xDelete<int>(pnvert);
 
 	clock1=clock();
Index: issm/branches/trunk-jpl-damage/src/c/modules/Exp2Kmlx/Exp2Kmlx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Exp2Kmlx/Exp2Kmlx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Exp2Kmlx/Exp2Kmlx.h	(revision 12878)
@@ -8,5 +8,5 @@
 #include <float.h>    /*  DBL_MAX  */
 #include "../../Container/Container.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 
 /* local prototypes: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.cpp	(revision 12878)
@@ -26,5 +26,5 @@
 	/*Get size of vector: */
 	gsize=nodes->NumberOfDofs(configuration_type,GsetEnum);
-	if (gsize==0) _error_("Allocating a Vec of size 0 as gsize=0 for configuration: %s",EnumToStringx(configuration_type));
+	if (gsize==0) _error2_("Allocating a Vec of size 0 as gsize=0 for configuration: " << EnumToStringx(configuration_type));
 	
 	/*Initialize solution: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.h	(revision 12878)
@@ -6,5 +6,5 @@
 #define _GETSOLUTIONFROMINPUTSXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.cpp	(revision 12878)
@@ -32,5 +32,5 @@
 
 	/*Assign output pointers:*/
-	xfree((void**)&control_type);
+	xDelete<int>(control_type);
 	*pvector=vector;
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromControlInputsx/GetVectorFromControlInputsx.h	(revision 12878)
@@ -5,5 +5,5 @@
 #define _GETVECTORFROMCONTROLINPUTSXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
Index: issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp	(revision 12878)
@@ -32,5 +32,5 @@
 	}
 	else{
-		_error_("%s%s%s"," vector type: ",EnumToStringx(type)," not supported yet!");
+		_error2_("vector type: " << EnumToStringx(type) << " not supported yet!");
 	}
 
@@ -41,8 +41,8 @@
 }
 
-void GetVectorFromInputsx( double** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, int name, int type){
+void GetVectorFromInputsx( IssmDouble** pvector, Elements* elements,Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters, int name, int type){
 	
 	/*output: */
-	double* vector=NULL;
+	IssmDouble* vector=NULL;
 	
 	/*intermediary: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.h	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.h	(revision 12878)
@@ -5,10 +5,10 @@
 #define _GETVECTORFROMINPUTSXX_H
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 
 /* local prototypes: */
 void	GetVectorFromInputsx( Vector** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,int name,int type);
-void	GetVectorFromInputsx( double** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,int name,int type);
+void	GetVectorFromInputsx( IssmDouble** pvector, Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads, Materials* materials,  Parameters* parameters,int name,int type);
 
 #endif  /* _GETVECTORFROMINPUTSXX_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Gradjx/Gradjx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Gradjx/Gradjx.cpp	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Gradjx/Gradjx.cpp	(revision 12878)
@@ -14,9 +14,9 @@
 	int     i,j,numberofvertices;
 	int     num_controls;
-	double  norm_inf;
-	double *norm_list       = NULL;
-	int    *control_type    = NULL;
-	Vector*     gradient        = NULL;
-	Vector*    *gradient_list   = NULL;
+	double   norm_inf;
+	double  *norm_list     = NULL;
+	int     *control_type  = NULL;
+	Vector  *gradient      = NULL;
+	Vector **gradient_list = NULL;
 	
 	/*retrieve some parameters: */
@@ -26,6 +26,6 @@
 
 	/*Allocate gradient_list */
-	gradient_list = (Vector**)xmalloc(num_controls*sizeof(Vector*));
-	norm_list = (double*)xmalloc(num_controls*sizeof(double));
+	gradient_list = xNew<Vector*>(num_controls);
+	norm_list = xNew<double>(num_controls);
 	for(i=0;i<num_controls;i++){
 		gradient_list[i]=new Vector(num_controls*numberofvertices);
@@ -54,6 +54,6 @@
 	/*Check that gradient is clean*/
 	norm_inf=gradient->Norm(NORM_INF);
-	if(norm_inf<=0)    _error_("||∂J/∂α||∞ = 0    gradient norm is zero");
-	if(isnan(norm_inf))_error_("||∂J/∂α||∞ = NaN  gradient norm is NaN");
+	if(norm_inf<=0)    _error2_("||∂J/∂α||∞ = 0    gradient norm is zero");
+	if(xIsNan<IssmDouble>(norm_inf))_error2_("||∂J/∂α||∞ = NaN  gradient norm is NaN");
 
 	/*Clean-up and assign output pointer*/
@@ -62,8 +62,8 @@
 	}
 	else{
-		xfree((void**)&norm_list);
+		xDelete<double>(norm_list);
 	}
 	if(pgradient)  *pgradient=gradient;
-	xfree((void**)&gradient_list);
-	xfree((void**)&control_type);
+	xDelete<Vector*>(gradient_list);
+	xDelete<int>(control_type);
 }
